-- Add some indices that are not included in the generated gemma-ddl.sql. Some of these are very important to performance

ALTER TABLE BIO_SEQUENCE
  ADD INDEX name (NAME);
ALTER TABLE ALTERNATE_NAME
  ADD INDEX name (NAME);
ALTER TABLE INVESTIGATION
  ADD INDEX name (NAME);
ALTER TABLE INVESTIGATION
  ADD INDEX shortname (SHORT_NAME);
ALTER TABLE INVESTIGATION
  ADD INDEX class (class);
ALTER TABLE DATABASE_ENTRY
  ADD INDEX acc_ex (ACCESSION, EXTERNAL_DATABASE_FK);
ALTER TABLE CHROMOSOME_FEATURE
  ADD INDEX symbol_tax (OFFICIAL_SYMBOL, TAXON_FK);
ALTER TABLE CHROMOSOME_FEATURE
  ADD INDEX ncbigeneid (NCBI_GENE_ID);
ALTER TABLE CHROMOSOME_FEATURE
  ADD INDEX ncbigi (NCBI_GI);
ALTER TABLE CHROMOSOME_FEATURE
  ADD INDEX previous_ncbiid (PREVIOUS_NCBI_ID);
ALTER TABLE CHROMOSOME_FEATURE
  ADD INDEX ensemblid (ENSEMBL_ID);
ALTER TABLE CHROMOSOME_FEATURE
  ADD INDEX name (NAME);
ALTER TABLE CHROMOSOME_FEATURE
  ADD INDEX class (class);
ALTER TABLE GENE_ALIAS
  ADD INDEX `alias` (`ALIAS`);
ALTER TABLE COMPOSITE_SEQUENCE
  ADD INDEX name (NAME);
ALTER TABLE PHYSICAL_LOCATION
  ADD INDEX BIN_KEY (BIN);
ALTER TABLE AUDIT_EVENT_TYPE
  ADD INDEX class (class);
ALTER TABLE ANALYSIS
  ADD INDEX class (class);
ALTER TABLE CHARACTERISTIC
  ADD INDEX value (VALUE);
ALTER TABLE CHARACTERISTIC
  ADD INDEX category (CATEGORY);
ALTER TABLE CHARACTERISTIC
  ADD INDEX valueUri (VALUE_URI);
ALTER TABLE CHARACTERISTIC
  ADD INDEX categoryUri (CATEGORY_URI);
ALTER TABLE GENE_SET
  ADD INDEX name (NAME);
ALTER TABLE PROCESSED_EXPRESSION_DATA_VECTOR
  ADD INDEX experimentProcessedVectorProbes (EXPRESSION_EXPERIMENT_FK, DESIGN_ELEMENT_FK);
ALTER TABLE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT
  ADD INDEX resultSetProbes (RESULT_SET_FK, PROBE_FK);
ALTER TABLE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT
  ADD INDEX probeResultSets (PROBE_FK, RESULT_SET_FK);
ALTER TABLE TAXON
  ADD INDEX taxonncbiid (NCBI_ID);
ALTER TABLE TAXON
  ADD INDEX taxonsecondncbiid (SECONDARY_NCBI_ID);
ALTER TABLE TAXON
  ADD INDEX taxoncommonname (COMMON_NAME);
ALTER TABLE TAXON
  ADD INDEX taxonscientificname (SCIENTIFIC_NAME);
ALTER TABLE CONTACT
  ADD INDEX fullname (NAME, LAST_NAME);

-- should remove the FIRST_GENE_FK and SECOND_GENE_FK indices, but they get given 'random' names.
-- Drop the second_gene_fk constraint.
-- alter table HUMAN_GENE_COEXPRESSION drop foreign key FKF9E6557F21D58F19;
-- alter table MOUSE_GENE_COEXPRESSION drop foreign key FKFC61C4F721D58F19;
-- alter table RAT_GENE_COEXPRESSION drop foreign key FKDE59FC7721D58F19;
-- alter table OTHER_GENE_COEXPRESSION drop foreign key FK74B9A3E221D58F19;

ALTER TABLE HUMAN_GENE_COEXPRESSION
  ADD INDEX hfgsg (FIRST_GENE_FK, SECOND_GENE_FK);
ALTER TABLE MOUSE_GENE_COEXPRESSION
  ADD INDEX mfgsg (FIRST_GENE_FK, SECOND_GENE_FK);
ALTER TABLE RAT_GENE_COEXPRESSION
  ADD INDEX rfgsg (FIRST_GENE_FK, SECOND_GENE_FK);
ALTER TABLE OTHER_GENE_COEXPRESSION
  ADD INDEX ofgsg (FIRST_GENE_FK, SECOND_GENE_FK);

-- same for these, should drop the key for EXPERIMENT_FK, manually
ALTER TABLE HUMAN_EXPERIMENT_COEXPRESSION
  ADD INDEX ECL1EFK (EXPERIMENT_FK, GENE1_FK, GENE2_FK),
  ADD CONSTRAINT ECL1EFK FOREIGN KEY (EXPERIMENT_FK) REFERENCES INVESTIGATION (ID);
ALTER TABLE MOUSE_EXPERIMENT_COEXPRESSION
  ADD INDEX ECL2EFK (EXPERIMENT_FK, GENE1_FK, GENE2_FK),
  ADD CONSTRAINT ECL2EFK FOREIGN KEY (EXPERIMENT_FK) REFERENCES INVESTIGATION (ID);
ALTER TABLE RAT_EXPERIMENT_COEXPRESSION
  ADD INDEX ECL3EFK (EXPERIMENT_FK, GENE1_FK, GENE2_FK),
  ADD CONSTRAINT ECL3EFK FOREIGN KEY (EXPERIMENT_FK) REFERENCES INVESTIGATION (ID);
ALTER TABLE OTHER_EXPERIMENT_COEXPRESSION
  ADD INDEX ECL4EFK (EXPERIMENT_FK, GENE1_FK, GENE2_FK),
  ADD CONSTRAINT ECL4EFK FOREIGN KEY (EXPERIMENT_FK) REFERENCES INVESTIGATION (ID);

-- candidates for removal
ALTER TABLE DIFFERENTIAL_EXPRESSION_ANALYSIS_RESULT
  ADD INDEX corrpvalbin (CORRECTED_P_VALUE_BIN);
ALTER TABLE HIT_LIST_SIZE
  ADD INDEX direction (DIRECTION);
