alter table GEEQ
drop column `SUITABILITY`,
drop column `QUALITY`,
add column `LAST_RUN_EVENT_FK` BIGINT(20) default null,
add column `LAST_MANUAL_OVERRIDE_EVENT_FK` BIGINT(20) default null,
add column `LAST_BATCH_EFFECT_CHANGE_EVENT_FK` BIGINT(20) default null,
add column `LAST_BATCH_CONFOUND_CHANGE_EVENT_FK` BIGINT(20) default null,

add column `DETECTED_QUALITY_SCORE` DOUBLE default 0.0,
add column `MANUAL_QUALITY_SCORE` DOUBLE default 0.0,
add column `MANUAL_QUALITY_OVERRIDE` BIT default 0,

add column `DETECTED_SUITABILITY_SCORE` DOUBLE default 0.0,
add column `MANUAL_SUITABILITY_SCORE` DOUBLE default 0.0,
add column `MANUAL_SUITABILITY_OVERRIDE` BIT default 0,

add column `SCORE_PUBLICATION` DOUBLE default 0.0,
add column `SCORE_PLATFORM_AMOUNT` DOUBLE default 0.0,
add column `SCORE_PLATFORMS_TECH_MULTI` DOUBLE default 0.0,
add column `SCORE_AVG_PLATFORM_POPULARITY` DOUBLE default 0.0,
add column `SCORE_AVG_PLATFORM_SIZE` DOUBLE default 0.0,
add column `SCORE_SAMPLE_SIZE` DOUBLE default 0.0,
add column `SCORE_RAW_DATA` DOUBLE default 0.0,
add column `SCORE_MISSING_VALUES` DOUBLE default 0.0,

add column `SCORE_OUTLIERS` DOUBLE default 0.0,
add column `SCORE_SAMPLE_MEAN_CORRELATION` DOUBLE default 0.0,
add column `SCORE_SAMPLE_MEDIAN_CORRELATION` DOUBLE default 0.0,
add column `SCORE_SAMPLE_CORRELATION_VARIANCE` DOUBLE default 0.0,
add column `SCORE_PLATFORMS_TECH` DOUBLE default 0.0,
add column `SCORE_REPLICATES` DOUBLE default 0.0,
add column `SCORE_BATCH_INFO` DOUBLE default 0.0,
add column `SCORE_BATCH_EFFECT` DOUBLE default 0.0,
add column `SCORE_BATCH_CONFOUND` DOUBLE default 0.0,

add column `MANUAL_HAS_STRONG_BATCH_EFFECT` BIT default 0,
add column `MANUAL_HAS_NO_BATCH_EFFECT` BIT default 0,
add column `MANUAL_BATCH_EFFECT_ACTIVE` BIT default 0,

add column `MANUAL_HAS_BATCH_CONFOUND` BIT default 0,
add column `MANUAL_BATCH_CONFOUND_ACTIVE` BIT default 0,

add column `NO_VECTORS` BIT default 0,
add column `CORRMAT_ISSUES` TINYINT default 0,
add column `REPLICATES_ISSUES` TINYINT default 0,
add column `BATCH_CORRECTED` BIT default 0,

add column `OTHER_ISSUES` VARCHAR(500);

alter table GEEQ
add constraint FK_1LAST_RUN_EVENT FOREIGN KEY(`LAST_RUN_EVENT_FK`) REFERENCES `AUDIT_EVENT`(`ID`),
add constraint FK_2LAST_MANUAL_OVERRIDE_EVENT FOREIGN KEY(LAST_MANUAL_OVERRIDE_EVENT_FK)  REFERENCES `AUDIT_EVENT`(`ID`),
add constraint FK_3LAST_BATCH_EFFECT_CHANGE_EVENT FOREIGN KEY(LAST_BATCH_EFFECT_CHANGE_EVENT_FK) REFERENCES `AUDIT_EVENT`(`ID`),
add constraint FK_4LAST_BATCH_CONFOUND_CHANGE_EVENT FOREIGN KEY(LAST_BATCH_CONFOUND_CHANGE_EVENT_FK) REFERENCES `AUDIT_EVENT`(`ID`);
